-- mySeq.e
-- v1.1
-- 2012-09-09
-- sequence functions
-- adapted to Euphoria 4.1

include std/types.e
include std/sequence.e
include std/text.e
include myTypes.e
include myDebug.e
include myConv.e

------------------------------------------------------------------------------

public function splitString(sequence str, atom sep)
-- splits str string in tokens according to separator sep
  integer slen
  sequence result, s
  integer tmpStr

  result = {}
  slen = length(str)
  if slen = 0 then return result end if
  
  s = {}
  tmpStr = 0      -- si 1, on est entre deux guillemets

  for i = 1 to slen do
    if (str[i] = '"') and (sep != '"') then
      if tmpStr = 0 then
        tmpStr = 1
      else
        tmpStr = 0
      end if
    else
      if tmpStr = 0 and str[i] = sep then
        result = append(result, trim(s))
        s = {}
          else
            s = s & str[i]
          end if
    end if
  end for
  result = append(result, trim(s))
  return result
end function

------------------------------------------------------------------------------

public function replaceString(sequence str, sequence old, sequence new)
-- replaces sub-sequence old by new in sequence str
  sequence s
  integer n, lg

  s = str
  lg = length(old)
  n = -1
  while n != 0 do
    n = match(old, s)
    if n > 1 then
      s = s[1..n-1]&new&s[n+lg..$]
    elsif n = 1 then
      s = new&s[n+lg..$]
    end if
  end while
  return s
end function

------------------------------------------------------------------------------

public function strtok(sequence str, atom sep)
-- splits str string in tokens according to separator sep
-- converts segments to atoms when needed
  sequence s

  s = split(str, sep)
  for i = 1 to length(s) do
    if isNumber(s[i]) or isHex(s[i]) then
      s[i] = val(s[i])
    elsif string(s[i]) then
      s[i] = dequote(s[i])
    end if
  end for
  return s
end function

------------------------------------------------------------------------------

public procedure hexDump(sequence s, integer output)
-- dumps a sequence in hex form to the specified output
  puts(output, "\n\nAddr  0  1  2  3  4  5  6  7  8  9  A  B  C  D  E  F\n")
  puts(output, "0000 ")
  for i = 1 to length(s) do
    puts(output, sprintf(" %02x", s[i]))
    if remainder(i, 16) = 0 then
      puts(output, sprintf("\n%04x ", floor(i/16)))
    end if
  end for
  puts(output, "\n\n")
end procedure

------------------------------------------------------------------------------

public function appendIfNew(sequence s, object o)
  if find(o, s) then
    return s
  else
    return append(s, o)
  end if
end function

-------------------------------------------------------------------------------

public function nbOccurences(sequence s, sequence item)
  integer nb, pos, lg

  nb = 0
  pos = 1
  lg = length(item)
  while pos > 0 do
    if match(item, s) then
      nb += 1
      s = remove(s, 1, pos+lg-1)
    end if
  end while
  return nb
end function

