-- myTypes.e
-- v1.0
-- 2010-11-13
-- common types

include std/types.e
include std/text.e

global constant
  ON = 1,
  OFF = 0,
  SUCCESS = 1,
  FAIL = 0

global constant
  DIGITS = "0123456789ABCDEF"

global object
  void    -- used when return value doesn't care

------------------------------------------------------------------------------

public function isString(object x)
-- checks if a sequence represents a string
  if not sequence(x) then return 0 end if
  if length(x) = 0 then return 1 end if
  for i = 1 to length(x) do
    if sequence(x[i]) then
      return 0
    elsif x[i] > 254 then
      return 0
    elsif (x[i] < 32) and not find(x[i], {9, 10, 13}) then
      return 0
    end if
  end for
  return 1
end function

------------------------------------------------------------------------------

public function isNumber(sequence x)
-- checks if a sequence represents a number
  integer lg
  sequence s
  
  s = trim(x)
  lg = length(s)
  if lg = 0 then return 0 end if
  for i = 1 to lg do
    if sequence(s[i]) then
      return 0
    else
      if ((s[i] < '0') or (s[i] > '9')) and (s[i] != ',') and (s[i] != '.') and (s[i] != '-') and (s[i] != '+') then return 0 end if
    end if
  end for
  return 1
end function

------------------------------------------------------------------------------

public function isDate(sequence x)
  integer n, n2

-- checks if a sequence represents a number
  n = length(x) if (n < 6) or (n > 10) then return 0 end if
  for i = 1 to length(x) do
    if sequence(x[i]) then return 0 end if
    if ((x[i] < '0') or (x[i] > '9')) and (x[i] != '/') then return 0 end if
    n = find('/', x) if (n != 2) and (n != 3) then return 0 end if
    n2 = find('/', x[n+1..$]) if (n2 != 2) and (n2 != 3) then return 0 end if
  end for
  return 1
end function

------------------------------------------------------------------------------

public function isHex(sequence x)
-- checks if a sequence represents a hexadecimal number
  integer lg
  sequence s

  s = trim(x)
  lg = length(s)
  if lg <= 1 then return 0 end if         -- min 2 cars (#n)
  if s[1] != '#' then return 0 end if
  return t_xdigit(s[2..$])
end function

